=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2011-02-21 07:27:20 +0000
+++ bzrlib/fetch.py	2011-02-25 03:00:35 +0000
@@ -350,7 +350,8 @@
 
     Factors that go into determining the sort of fetch to perform:
      * did the caller specify any revision IDs?
-     * did the caller specify a source branch (need to fetch the tip + tags)
+     * did the caller specify a source branch (need to fetch its
+       heads_to_fetch(), usually the tip + tags)
      * is there an existing target repo (don't need to refetch revs it
        already has)
      * target is stacked?  (similar to pre-existing target repo: even if
@@ -392,7 +393,7 @@
                     self.target_repo, self.source_repo).execute()
         heads_to_fetch = set(self._explicit_rev_ids)
         if self.source_branch is not None:
-            must_fetch, tags_to_fetch = self.source_branch.heads_to_fetch()
+            must_fetch, if_present_fetch = self.source_branch.heads_to_fetch()
             if self.source_branch_stop_revision_id is not None:
                 # Replace the tip rev from must_fetch with the stop revision
                 # XXX: this might be wrong if the tip rev is also in the
@@ -403,17 +404,17 @@
                 must_fetch.add(self.source_branch_stop_revision_id)
             heads_to_fetch.update(must_fetch)
         else:
-            tags_to_fetch = set()
+            if_present_fetch = set()
         if self.target_repo_kind == TargetRepoKinds.EMPTY:
             # PendingAncestryResult does not raise errors if a requested head
             # is absent.  Ideally it would support the
             # required_ids/if_present_ids distinction, but in practice
             # heads_to_fetch will almost certainly be present so this doesn't
             # matter much.
-            all_heads = heads_to_fetch.union(tags_to_fetch)
+            all_heads = heads_to_fetch.union(if_present_fetch)
             return graph.PendingAncestryResult(all_heads, self.source_repo)
         return graph.NotInOtherForRevs(self.target_repo, self.source_repo,
-            required_ids=heads_to_fetch, if_present_ids=tags_to_fetch
+            required_ids=heads_to_fetch, if_present_ids=if_present_fetch
             ).execute()
 
 

